/********************************************************/
/*                                                      */
/*               OO7 Benchmark                          */
/*                                                      */
/*              COPYRIGHT (C) 1993                      */
/*                                                      */
/*                Michael J. Carey 		        */
/*                David J. DeWitt 		        */
/*                Jeffrey Naughton 		        */
/*               Madison, WI U.S.A.                     */
/*                                                      */
/*	         ALL RIGHTS RESERVED                    */
/*                                                      */
/********************************************************/


////////////////////////////////////////////////////////////////////////////
//
// Connection Methods
//
////////////////////////////////////////////////////////////////////////////

#include <libc.h>
#include <stdio.h>
#include <strings.h>
#include <List.h>
#include "oo7.h"
#include "globals.h"
#include "GenParams.h"

extern int	debugMode;
extern char*	types[NumTypes];

////////////////////////////////////////////////////////////////////////////
//
// Connection Constructor
//
////////////////////////////////////////////////////////////////////////////

Connection::Connection(AtomicPart* fromPart, AtomicPart* toPart)
{
    if (debugMode) {
        printf("Connection::Connection(fromId = %d, toId = %d)\n",
            fromPart->id, toPart->id);
    }

    // initialize the direct type (ONTOS requirement.)
    initDirectType(ConnectionType);     

    // initialize the simple stuff
    int typeNo = (int) (random() % NumTypes);
    strncpy(type, types[typeNo], TypeSize);
    length = (int) (random() % XYRange);

    // initialize fromReference.
    fromReference.Init(fromPart);

    // initialize toReference.
    toReference.Init(toPart);

    // insert Reference to this connection object
    // into appropriate atomic part's "to" list
    (fromPart->to())->Insert(this); 
    // write the change to the DB
    (fromPart->to())->putObject(); 

    // insert Reference to this connection object
    // into appropriate atomic part's "from" list
    (toPart->from())->Insert(this); 
    // write the change to the DB
    (toPart->from())->putObject(); 

}

////////////////////////////////////////////////////////////////////////////
//
// Extra constructor required by Ontos.
//
////////////////////////////////////////////////////////////////////////////

Connection::Connection(APL *theAPL) : Object(theAPL) {}


////////////////////////////////////////////////////////////////////////////
//
// getDirectType required by ONTOS.
//
////////////////////////////////////////////////////////////////////////////

Type *Connection::getDirectType() {
//    return (Type*)OC_lookup("Connection");
    return CONType;
}


/*  $Version: Connection.C 1.2 93/02/22 15:59:31 Exp $ */

